<template>
  <st-content :heading="tutoria.nombre" @goingBack="cleanAllTutorshipData">
    <st-back-btn />
    <st-students-modal v-model="showModalStudents" @refreshData="refreshDataStudents"></st-students-modal>
    <st-tutors-modal v-model="showModalTutors" @refreshData="refreshDataTutors"></st-tutors-modal>
    <div>
      <!--  TUTORSHIP DATA SECTION -->
      <v-row class="my-4">
        <v-col md="12">
          <st-tutorship-data
            :tutorshipName="tutoria.nombre"
            :tutorshipDescription="tutoria.descripcion"
            :tutorshipSessionsNumber="tutoria.numSesiones"
            :tutorshipType1="tutoria.tipoTutoria.tutorFijo"
            :tutorshipType2="tutoria.tipoTutoria.tutorAsignado"
            :tutorshipType3="tutoria.tipoTutoria.individual"
            :tutorshipType4="tutoria.tipoTutoria.obligatoria"
            @refreshData="refreshData"
          />
        </v-col>
      </v-row>

      <!--  TUTORSHIP SESSIONS SECTION -->
      <v-row class="my-4">
        <v-col md="12">
          <st-tutorship-sessions @emitGoSessionPage="goSessionPage" :sessionPath="sessionPath" />
        </v-col>
      </v-row>

      <!--  TUTORS AND STUDENTS SECTION -->
      <v-row class="my-4">
        <v-col md="6">
          <st-tutorship-tutors />
        </v-col>
        <v-col md="6">
          <st-tutorship-students />
        </v-col>
      </v-row>
    </div>
  </st-content>
</template>

<script>
import Register from "@/components/tutorship/Register";
import TutorshipTutorsSection from "../../../../components/TutorshipTutorsSection";
import TutorshipStudentsSection from "../../../../components/TutorshipStudentsSection";
import TutorshipSessionsSection from "../../../../components/TutorshipSessionsSection";
import TutorshipDataSection from "../../../../components/TutorshipDataSection";
import TutorshipStudentsModal from "../../../../components/TutorshipStudentsModal";
import TutorshipTutorsModal from "../../../../components/TutorshipTutorsModal";
import { mapState } from "vuex";

export default {
  data() {
    return {
      sessionPath: "/coordinador/tutorias/"
    };
  },
  computed: {
    ...mapState("tutorships", {
      tutoria: state => state.tutoria,
      totalTutores: state => state.totalTutores,
      tutores: state => state.tutores,
      totalAlumnos: state => state.totalAlumnos,
      alumnos: state => state.alumnos,
      loading: state => state.loading,
      showModalStudents: state => state.showModalStudents,
      showModalTutors: state => state.showModalTutors
    })
  },
  components: {
    TutorshipDataSection,
    "st-tutorship-data": TutorshipDataSection,
    "st-tutorship-tutors": TutorshipTutorsSection,
    "st-tutorship-students": TutorshipStudentsSection,
    "st-tutorship-sessions": TutorshipSessionsSection,
    "st-students-modal": TutorshipStudentsModal,
    "st-tutors-modal": TutorshipTutorsModal
  },
  methods: {
    buildSessionPath() {
      this.sessionPath =
        "/coordinador/tutorias/" + this.$route.params.id + "/sesiones";
    },
    goSessionPage() {
      this.$router.push(this.sessionPath);
    },
    refreshDataStudents() {},
    refreshDataTutors() {},
    cleanAllTutorshipData() {
      this.$store.dispatch("tutorships/cleanAllTutorshipData");
    },
    refreshData() {
      this.cleanAllTutorshipData();
      this.buildSessionPath();
      const idTutorship = this.$route.params.id;
      if (
        !this.tutoria ||
        !this.tutoria.idTutoria ||
        this.tutoria.idTutoria !== id
      ) {
        this.$store.dispatch("tutorships/selectTutorship", {
          idTutorship: idTutorship
        });
      }
    }
  },
  mounted() {
    this.cleanAllTutorshipData();
    this.buildSessionPath();
    const idTutorship = this.$route.params.id;
    if (
      !this.tutoria ||
      !this.tutoria.idTutoria ||
      this.tutoria.idTutoria !== id
    ) {
      this.$store.dispatch("tutorships/selectTutorship", {
        idTutorship: idTutorship
      });
    }
  }
};
</script>

<style scoped lang="scss">
.col {
  padding-top: 0;
  padding-bottom: 0;
}
</style>
